# -*- coding: utf-8 -*-

from PyQt4.QtCore import *
from PyQt4.QtGui import QImage, QPainter
from PyKDE4.plasma import Plasma
from PyKDE4 import plasmascript

class BEnma(plasmascript.Applet):
    def __init__(self,parent,args=None):
        plasmascript.Applet.__init__(self,parent)

    def init(self):
        self.setAspectRatioMode(Plasma.KeepAspectRatio)

        # TODO: make option
        self.setHasConfigurationInterface(False)
        self.setBackgroundHints(Plasma.Applet.NoBackground)

        self.svgEnmaNegative = Plasma.Svg(self)
        self.svgEnmaNegative.setImagePath(self.package().filePath("images", "enma-negative.svg"))
        self.svgEnma = Plasma.Svg(self)
        self.svgEnma.setImagePath(self.package().filePath("images", "enma.svg"))
        self.svgTexture = Plasma.Svg(self)
        self.svgTexture.setImagePath(self.package().filePath("images", "textur.svg"))

        self.imageFormat = QImage.Format_ARGB32_Premultiplied
        self.image = QImage(self.size().width(), self.size().height(), self.imageFormat)

        self.textureOffset = 0
        self.textureOffsetSpeed = 1
        self.oldSize = self.size()

        self.timer = QTimer(self)
        self.connect(self.timer, SIGNAL ("timeout ()"), self.updateTextureoffset)
        self.timer.start(200)
 
    def paintInterface(self, painter, option, rect):
        painter.drawImage(0, 0, self.image)
        self.svgEnma.paint(painter, 0, 0)

    def updateSvgSize(self, size):
        self.svgEnmaNegative.resize(size)
        self.svgEnma.resize(size)
        self.svgTexture.resize(size)
        self.image = QImage(size.width(), size.height(), self.imageFormat)
        self.updateImage()

    def updateImage(self):
        painter = QPainter(self.image)
        painter.setCompositionMode(QPainter.CompositionMode_Source)
        painter.fillRect(self.image.rect(), Qt.transparent)
        painter.setCompositionMode(QPainter.CompositionMode_SourceOver)
        self.svgEnmaNegative.paint(painter, 0, 0)
        painter.setCompositionMode(QPainter.CompositionMode_SourceIn)
        if self.textureOffset == 0:
            self.svgTexture.paint(painter, 0, 0)
        else:
            self.svgTexture.paint(painter, 0, self.textureOffset)
            self.svgTexture.paint(painter, 0, -self.svgTexture.size().height() + self.textureOffset)
        painter.end()

    def constraintsEvent(self, constraints):
        if constraints & Plasma.FormFactorConstraint:
            self.setBackgroundHints(Plasma.Applet.NoBackground)

        if constraints & Plasma.SizeConstraint:
            self.updateSvgSize(self.size())

            # update texture offset
            if self.oldSize.height() == 0:
                self.textureOffset = 0
            else:
                self.textureOffset = self.textureOffset / self.oldSize.height() * self.size().height()
            self.oldSize = self.size()

    def updateTextureoffset(self):
        self.textureOffset += self.textureOffsetSpeed
        if self.textureOffset > self.size().height():
            self.textureOffset -= self.size().height()
        self.updateImage()
        self.update()



def CreateApplet(parent):
    return BEnma(parent)

